#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,float *B7,float *B8,int N){
for(int i=0;i<N;i++){
A0[i] = A4[i]*A3[i]/A4[i]/A3[i];
A1[i] = A4[i];
A2[i] = A3[i];
B0[i] = B3[i]*B6[i];
B1[i] = B5[i]-B6[i]/B4[i];
B2[i] = B5[i];
}
}

int main(int argc,char **argv) {
int size=32396;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
float *B7;
B7 = (float *)malloc(floatBytes);
float *B8;
B8 = (float *)malloc(floatBytes);
for(int i=0;i<32396;i++){
A0[i] = 41*i+1;
A1[i] = 16+i+1;
A2[i] = 22+i+1;
A3[i] = 81+i+1;
A4[i] = 57+i+1;
B0[i] = 68.5791097092+i+1;
B1[i] = 78.4946976851+i+1;
B2[i] = 63.9411840461+i+1;
B3[i] = 54.4343383468+i+1;
B4[i] = 72.8862604956*i+1;
B5[i] = 2.34834432085+i+1;
B6[i] = 32.6136802964*i+1;
B7[i] = 72.7785292663+i+1;
B8[i] = 3.19666950662+i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,B0,B1,B2,B3,B4,B5,B6,B7,B8,32396);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
free(B7);
free(B8);
printf("\n");return 0; }